;;; -*- mode: LISP; package: CLONES -*-

(in-package #:clones)


(defclass cell ()
  ((x :initarg :x
      :accessor cell-x
      :type fixnum
      :initform 0)
   (y :initarg :y
      :accessor cell-y
      :type fixnum
      :initform 0)
   (color :initarg :color
          :accessor cell-color
          :initform :empty)
;;    (highlight-p :initarg :highlight-p
;;                 :accessor cell-highlight-p
;;                 :type boolean
;;                 :initform nil)
   (field :initarg :field
          :accessor cell-field)))


(defmethod print-object ((object cell) stream)
  (print-unreadable-object (object stream :type t :identity t)
    (with-slots (x y color) object
      ;; Shows names of highlighted cells in uppercase
      (format stream "~A@~D,~D" color x y))))


(defun cell-empty-p (cell)
  (eq :empty (cell-color cell)))


(defun (setf cell-highlight-p) (value cell)
  (let ((color (cell-color cell)))
    (unless (eq :empty color)
      (let ((position (position (cell-color cell) *colors*)))
        (cond (value
               (when (< position +color-count+)
                 (setf (cell-color cell)
                       (svref *colors* (incf position +color-count+)))))
              (t
               (when (<= +color-count+ position)
                 (setf (cell-color cell)
                       (svref *colors* (decf position +color-count+))))))))))

;; (defmethod (setf cell-color) :before (value (object cell))
;;   "Removes highlight when cell is emptied."
;;   (unless (= value (cell-color object))
;;     (setf (cell-dirty-p object) t)
;;     (when (cell-empty-p object)
;;       (setf (cell-highlight-p object) nil))))


;; (defmethod (setf cell-highlight-p) :before (value (object cell))
;;   (unless (eq value (cell-highlight-p object))
;;     (setf (cell-dirty-p object) t)))


(defun same-cell-p (a b)
  (and (= (cell-x a)
          (cell-x b))
       (= (cell-y a)
          (cell-y b))))



;; (defun cells-equal-for-redraw (a b)
;;   (and (= (cell-color a)
;;           (cell-color b))
;;        (eq (cell-highlight-p a)
;;            (cell-highlight-p b))))
