;;; -*- mode: LISP -*-

(in-package #:cl-user)

#+lispworks
(eval-when (:compile-toplevel :load-toplevel :execute)
  (unless (find-package '#:asdf)
    (load "/usr/share/common-lisp/source/asdf/asdf")))

(defpackage #:clones.system
  (:use #:common-lisp #:asdf))

(in-package #:clones.system)

(defsystem clones-clim
  :name "clones"
  :author "Janis Dzerins <jdz@dir.lv>"
  :version "0.1"
  :licence "Public Domain"

  :components ((:file "package")
               (:file "vars" :depends-on ("package"))
               (:file "cell" :depends-on ("package"))
               (:file "field" :depends-on ("package" "vars" "cell"))
               (:file "scores" :depends-on ("package" "vars"))
               (:file "scores-frame" :depends-on ("package" "scores"))
               (:file "theme" :depends-on ("package" "vars"))
               (:file "pixmap-theme" :depends-on ("package" "vars" "theme"))
               (:file "game" :depends-on ("package" "vars" "field" "cell" "theme"
                                          "pixmap-theme"
                                          "scores" "scores-frame"))))
