;;; -*- mode: LISP; package: CLONES.CLIM -*-

(in-package #:clones.clim)


;;; Pixmap themes -- very platform dependant at the moment!


;; (defun make-image-pixmap (image-data pane)
;;   (destructuring-bind (height width) (array-dimensions image-data)
;;     (with-output-to-pixmap (medium pane :width width :height height)
;;       (clim-clx::draw-image (medium-sheet medium)
;;                             image-data
;;                             :clipping-region (make-rectangle* 0 0 width height)))))


;; (defclass pixmap-theme (theme)
;;   ((name :initarg :name
;;          :accessor pixmap-theme-name)
;;    (pixmaps)))


;; (defmethod initialize-theme ((theme pixmap-theme) pane)
;;   (with-slots (cell-width cell-height name pixmaps) theme
;;     (let* ((images (mapcar #'image:read-image-file
;;                            (mapcar #'(lambda (file-name)
;;                                        (merge-pathnames
;;                                         (make-pathname :directory `(:relative ,name)
;;                                                        :name file-name
;;                                                        :type "ppm")
;;                                         *pixmap-theme-dir*))
;;                                    *pixmap-image-names*))))
;;       (destructuring-bind (height width) (array-dimensions (car images))
;;         ;; Allow only same-sized images at the moment
;;         (assert (and (every #'(lambda (image) (= height (array-dimension image 0))) (cdr images))
;;                      (every #'(lambda (image) (= width (array-dimension image 1))) (cdr images))))
;;         (setf cell-width width
;;               cell-height height
;;               pixmaps (map 'vector
;;                            #'(lambda (data)
;;                                (make-image-pixmap data pane))
;;                            images))))))



;; (defmethod draw-cell ((theme pixmap-theme) cell stream)
;;   (with-slots (cell-width cell-height pixmaps) theme
;;     (with-slots (x y) cell
;;       (let ((x1 (* x cell-width))
;;             (y1 (* y cell-height)))
;;         (cond ((eq :empty (cell-color cell))
;;                ;; Empty cell -- draw a black rectangle
;;                (let ((x2 (+ x1 cell-width))
;;                      (y2 (+ y1 cell-width)))
;;                  (draw-rectangle* stream x1 y1 x2 y2 :filled t :ink +black+)))
;;               (t
;;                (copy-from-pixmap (svref pixmaps (position (cell-color cell) *colors*))
;;                                  0 0 cell-width cell-height stream x1 y1)))))))


(eval-when (:compile-toplevel :load-toplevel :execute)
  (unless (let ((symbol (find-symbol "XPM-PARSE-FILE" '#:clim-internals)))
            (and symbol (fboundp symbol )))
    (load (merge-pathnames #p"Experimental/xpm.lisp" cl-user::*clim-directory*))))


(defclass pixmap-theme (theme)
  ((patterns)))


(defmethod initialize-instance :after ((theme pixmap-theme)
                                       &key name &allow-other-keys)
  (with-slots (cell-width cell-height patterns) theme
    (let* ((images (mapcar #'climi::xpm-parse-file
                           (mapcar #'(lambda (file-name)
                                       (merge-pathnames
                                        (make-pathname :directory `(:relative ,name)
                                                       :name file-name
                                                       :type "xpm")
                                        *pixmap-theme-dir*))
                                   *pixmap-image-names*))))
      (let ((width (pattern-width (car images)))
            (height (pattern-height (car images))))
        ;; Allow only same-sized images at the moment
        (assert (and (every #'(lambda (image) (= height (pattern-height image))) (cdr images))
                     (every #'(lambda (image) (= width (pattern-width image))) (cdr images)))
                (images)
                "All images should be of equal dimensions: ~S" images)

        (setf cell-width width
              cell-height height
              patterns (map 'vector #'identity images))))))


(defmethod draw-cell ((theme pixmap-theme) cell stream)
  (with-slots (cell-width cell-height patterns) theme
    (with-slots (x y) cell
      (let ((x1 (* x cell-width))
            (y1 (* y cell-height)))
        (draw-pattern* stream 
                       (svref patterns (position (cell-color cell) *colors*))
                       x1 y1)))))
