;;; -*- mode: LISP; package: CLONES.CLIM -*-

(in-package #:clones.clim)


(define-application-frame clones-scores ()
  ((scores :initarg :scores
           :accessor scores
           :initform nil))
  (:panes
   (list :application
         :display-function 'draw-scores
         :incremental-redisplay t
         :scroll-bars nil
         :text-cursor nil
         :width :compute
         :height :compute)
   (button push-button
           :label "Ok"
           :activate-callback #'(lambda (button)
                                  (declare (ignore button))
                                  (frame-exit *application-frame*))))
  (:layouts
   (default
     (vertically ()
       list button))))


(defun universal-time-string (time)
  (multiple-value-bind (ss mm hh date month year)
      (decode-universal-time time)
    (format nil "~D-~2,'0D-~2,'0D ~2,'0D:~2,'0D:~2,'0D"
            year month date hh mm ss)))


(defun draw-scores (frame stream)
  (with-slots (scores) frame
    (formatting-table (stream)
      (formatting-row (stream)
        (formatting-cell (stream) (write-string "Score" stream))
        (formatting-cell (stream) (write-string "Name" stream))
        (formatting-cell (stream) (write-string "Date" stream)))
      (dolist (score scores)
        (formatting-row (stream)
          (formatting-cell (stream)
            (princ (amount score) stream))
          (formatting-cell (stream)
            (write-string (name score) stream))
          (formatting-cell (stream)
            (write-string (universal-time-string (date score)) stream)))))))
